<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0"
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:java="http://xml.apache.org/xslt/java"
	xmlns:util="xalan://org.greenstone.gsdl3.util.XSLTUtil"
	xmlns:gslib="http://www.greenstone.org/skinning"
	xmlns:gsf="http://www.greenstone.org/greenstone3/schema/ConfigFormat"
	extension-element-prefixes="java util"
	exclude-result-prefixes="java util gsf">

  <!--
	  <img src="interfaces/{$interface_name}/images/iworld.gif"/>
  -->
  
  <xsl:template name="documentHeading">
    <gsf:script src="sites/{$site_name}/collect/{$collName}/js/jquery.show-more.js"/>
    
    <span style="font-weight:bold; font-size: 120%;">
      <gsf:switch>
        <gsf:metadata name='FromCountry'/>	
        <gsf:when test='exists'>
	  <gsf:metadata name='FromCountry'/>
	  voting in
	  <gsf:metadata name='FromCountryYear'/>
	</gsf:when>
	<gsf:otherwise>
	  <xsl:call-template name="choose-title"/>
	</gsf:otherwise>
      </gsf:switch>
    </span>
    <div style="clear:both;"><xsl:text> </xsl:text></div>
    
    <div>
     <style>
      table.esc-metadata tr:nth-child(odd) {
        background-color: rgba(255,255,255,0.2);
      }
      table.esc-metadata tr:nth-child(even) {
        background-color: rgba(255,255,255,0.0);
      }
	
      table.esc-metadata {
        margin-top: 5px;
        min-width: 650px;
        padding: 10px;
      }
     </style>

    <!-- prov:wasDerivedFrom -->
    <xsl:variable name="escyear"><gsf:metadata name="Year"/></xsl:variable>

     <div style="float: right;">
       <gsf:switch>
	<gsf:metadata name='YearLogoImg'/>
	<gsf:when test='exists'>
	  <style>
	    div.esc-logo { height: 100px; width: 180px;}
	    div.esc-logo img { width: 100%; height: 100%; object-fit: scale-down; background-color: #fff}
	  </style>
	  <div class="esc-logo">
	    <a target="_blank" class="esc-logo" title="Access Wikipedia article about the contenst this year"
	       href="https://en.wikipedia.org/wiki/Eurovision_Song_Contest_{$escyear}">
	      <gsf:metadata name="YearLogoImg"/>
	      <!--
		  <img style="vertical-align: top;"
		  src="data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAAoAAAAKCAYAAACNMs+9AAAAVklEQVR4Xn3PgQkAMQhDUXfqTu7kTtkpd5RA8AInfArtQ2iRXFWT2QedAfttj2FsPIOE1eCOlEuoWWjgzYaB/IkeGOrxXhqB+uA9Bfcm0lAZuh+YIeAD+cAqSz4kCMUAAAAASUVORK5CYII="
		  alt="external link" />
	      -->
	    </a>
	  </div>
	</gsf:when>
	<gsf:otherwise>
	  <gsf:space/>
	</gsf:otherwise>
       </gsf:switch>
     </div>
     
     <table
	 prefix="mo: http://purl.org/ontology/mo/
              dc: http://purl.org/dc/elements/1.1/
              xsd: http://www.w3.org/2001/XMLSchema#
              tl: http://purl.org/NET/c4dm/timeline.owl#
              event: http://purl.org/NET/c4dm/event.owl#
              foaf: http://xmlns.com/foaf/0.1/
              rdfs: http://www.w3.org/2000/01/rdf-schema#"
	      
	 class="esc-metadata" style="float: left;">
      
      <gsf:switch>
        <gsf:metadata name='FromCountry'/>
        <gsf:when test='exists'>
	  <tr>
	    <td>
	      Voting Type:
	    </td>
	    <td>
	      <!--
	      <gsf:switch>
		<gsf:metadata name='FromCountryType'/>	
		<gsf:when test="equals" test-value="J">
		  Jury
		</gsf:when>
		<gsf:when test="equals" test-value="T">
		  Televotes
		</gsf:when>
		<gsf:otherwise>
		  Separate Jury and Televotes Added Together
		</gsf:otherwise>
	      </gsf:switch>

	      -->

	      <gsf:switch>
		<gsf:metadata name='FromCountryNuancedType'/>	
		<gsf:when test="equals" test-value="J">
		  Jury
		</gsf:when>
		<gsf:when test="equals" test-value="T">
		  Televotes
		</gsf:when>
		<gsf:when test="equals" test-value="C">
		  Combined Jury and Televotes
		</gsf:when>
		<gsf:otherwise>

		  <gsf:switch>
		    <gsf:metadata name='FromCountryType'/>
		    <gsf:when test="equals" test-value="J">
		      Jury
		    </gsf:when>
		    <gsf:when test="equals" test-value="T">
		      Televotes
		    </gsf:when>
		    <gsf:otherwise> <!-- JT -->
		      Separate Jury and Televotes Added Together
		    </gsf:otherwise>
		  </gsf:switch>
		  
		</gsf:otherwise>
	      </gsf:switch>

	      
	    </td>
	  </tr>	  
	  <tr>
	    <td>
	      Votes cast by:
	    </td>
	    <td>
	      <gsf:metadata name="FromCountry" highlight="highlight" />
	    </td>
	  </tr>
	  <tr>
	    <td>
	      Year:
	    </td>
	    <td>
	      <gsf:metadata name="FromCountryYear" highlight="highlight" />
	    </td>
	  </tr>
	</gsf:when>

	<gsf:otherwise>
	  <tr>
	    <td>
	      <!--
	       XX<xsl:value-of select="util:getInterfaceText($interface_name, /page/@lang, 'Artist')"/>XX
	      -->
	      Title:
	    </td>
	    <td>
	      <gsf:switch>
		<gsf:metadata name='WikipediaURL_uri' />
		<gsf:when test='exists'>

		  <a target="_blank">
		    <xsl:attribute name="href">
		      <gsf:metadata name="WikipediaURL_uri" />
		    </xsl:attribute>

		    <span typeof="mo:Track" about="#track-1">
		      <span property="dc:title"><gsf:metadata name="Title" highlight="highlight" /></span>
		    </span>
		    @ Wikipedia
		    <img src="data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAAoAAAAKCAYAAACNMs+9AAAAVklEQVR4Xn3PgQkAMQhDUXfqTu7kTtkpd5RA8AInfArtQ2iRXFWT2QedAfttj2FsPIOE1eCOlEuoWWjgzYaB/IkeGOrxXhqB+uA9Bfcm0lAZuh+YIeAD+cAqSz4kCMUAAAAASUVORK5CYII=" alt="external link" />
		  </a>
		</gsf:when>
		<gsf:otherwise>
		  <span typeof="mo:Track" about="#track-1">
		    <span property="dc:title"><gsf:metadata name="Title" highlight="highlight" /></span>
		  </span>
		</gsf:otherwise>
	      </gsf:switch>
	    </td>
	  </tr>
	</gsf:otherwise>
      </gsf:switch>

      <gsf:switch>
        <gsf:metadata name='Creator'/>
        <gsf:when test='exists'>
	  <tr>
	    <td>
	      Artist:
	    </td>
	    <td>
	      <span property="foaf:name"><gsf:metadata name="Creator" highlight="highlight" /></span>	      
	    </td>
	  </tr>
	</gsf:when>
      </gsf:switch>

      <gsf:switch>
        <gsf:metadata name='Country'/>
        <gsf:when test='exists'>
	  <tr>
	    <td>
	      Country:
	    </td>
	    <td>

	      <gsf:switch>
		<gsf:metadata name='FlagImg'/>
		<gsf:when test='exists'>
		  <span style="padding-right: 6px;"><gsf:metadata name="FlagImg"/></span>
		</gsf:when>
	      </gsf:switch>

	      <gsf:metadata name="Country" highlight="highlight" />

	    </td>
	  </tr>
	</gsf:when>
      </gsf:switch>

      <gsf:switch>
        <gsf:metadata name='Year'/>
        <gsf:when test='exists'>
	  <tr>
	    <td>
	      Year:
	    </td>
	    <td>
	      <gsf:variable name="Year"><gsf:metadata name="Year"/></gsf:variable>	      
	      <span property="dc:coverage" datatype="xsd:date" content="{$Year}"><gsf:metadata name="Year" highlight="highlight" /></span>
	      	      
	      <!--
	      <a target="_blank" href="https://en.wikipedia.org/wiki/Eurovision_Song_Contest_{$escyear}">
		Eurovision <gsf:metadata name="Year" highlight="highlight" />
		@ Wikipedia
		<img src="data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAAoAAAAKCAYAAACNMs+9AAAAVklEQVR4Xn3PgQkAMQhDUXfqTu7kTtkpd5RA8AInfArtQ2iRXFWT2QedAfttj2FsPIOE1eCOlEuoWWjgzYaB/IkeGOrxXhqB+uA9Bfcm0lAZuh+YIeAD+cAqSz4kCMUAAAAASUVORK5CYII=" alt="external link" />
	      </a>
	      -->
	      
	    </td>
	  </tr>
	</gsf:when>
      </gsf:switch>


      <gsf:switch>
        <gsf:metadata name='essentia.rhythm_bpm'/> 
        <gsf:when test='exists'>
	  <tr>
	    <td>
	      Beats per minute (bpm):
	    </td>
	    <td>
	      <gsf:variable name="BPM"><gsf:metadata name="essentia.rhythm_bpm" /></gsf:variable>
	      <span property="mo:bpm" datatype="xsd:float" content="{$BPM}" id="essentia-rhythm_bpm"></span>	    
	      <gsf:script>
		$( document ).ready(function() {
		  var bpm = Math.round(gs.documentMetadata["essentia_rhythm_bpm"])
		  $("#essentia-rhythm_bpm").html(bpm)
		})
	      </gsf:script>
	    </td>
	  </tr>
	</gsf:when>
      </gsf:switch>

      
      <gsf:switch>
        <gsf:metadata name='essentia.tonal_key_edma_key'/> 
        <gsf:when test='exists'>
	  <tr>
	    <td>
	      Estimated Key:
	    </td>
	    <td>
	      <gsf:metadata name="essentia.tonal_key_edma_key" highlight="highlight" /><gsf:space/><gsf:metadata name="essentia.tonal_key_edma_scale" highlight="highlight" />
	    </td>
	  </tr>
	</gsf:when>
      </gsf:switch>


      
     </table>

     <div style="clear:both;"><xsl:text> </xsl:text></div>

       <gsf:switch>
         <gsf:metadata name='lyrics'/> 
         <gsf:when test='exists'>
	   <div style="padding-top: 10px; padding-bottom: 0px;">
	     <hr />
	     <div>
	       <b>Lyrics:</b>
	     </div>
	     <gsf:div id="lyrics-first-block"/>
	     <div id="lyrics-div-show-more">
	       <div id="lyrics-div" style="display: none;">
		 <span property="mo:lyrics" datatype="xsd:string" id="lyrics"><gsf:metadata name="lyrics" highlight="highlight" pos="first"/></span>
	       </div>
	     </div>
	     
	     <gsf:script>
	       function pretty_print_lyrics(lyrics) {
        	 pp_lyrics = lyrics.replace(/\\\\n/g,"⏎")
	         pp_lyrics = pp_lyrics.replace(/⏎⏎/g,"&lt;hr class=\"verse-divider\"/&gt;")
	         pp_lyrics = pp_lyrics.replace(/⏎/g," ⏎ ")

		 return pp_lyrics
		 }
		 
	       $( document ).ready(function() {
	         var lyrics = $('#lyrics').html();
	         lyrics = lyrics.replace(/\\\\n\\n/g,"⏎⏎")

		 var first_block_pos = lyrics.indexOf("⏎⏎")
		 if (first_block_pos != -1) {
		   var lyrics_first_block = lyrics.substring(0,first_block_pos)
		   var lyrics_remaining   = lyrics.substring(first_block_pos)
		 }
		 else {
		   var lyrics_first_block = ""
		   var lyrics_remaining   = lyrics
		 }

	         lyrics_first_block = pretty_print_lyrics(lyrics_first_block)
	         lyrics_remaining = pretty_print_lyrics(lyrics_remaining)
		 
	         $("#lyrics-first-block").html(lyrics_first_block)
	         $("#lyrics").html(lyrics_remaining)
		 
	         $("#lyrics-div").show()

	         $('#lyrics-div-show-more').showMore({
	            minheight: 0,
		    buttontxtmore:"show more ...",
		    buttontxtless:"... show less"
	          });
		 
	       })
	     </gsf:script>
	     <hr />
	     
	   </div>
	 </gsf:when>
       </gsf:switch>
     </div>
     

  </xsl:template>

  <xsl:template name="documentContentFromCountry">
    <div id="from-country-votes">
      <gsf:script>
	$(document).ready(function() {
	  append_all_from_country_votes();
	});	

	window.addEventListener("resize", function() { append_all_from_country_votes() });
      </gsf:script>
    </div>    
  </xsl:template>
  
  <xsl:template name="documentContentEntry">
    <gsf:switch>
      <gsf:metadata name='Abstract_en'/>
      <gsf:when test='exists'>
	<div style="padding-top: 10px;padding-bottom: 10px; font-style: italic;">
	  <gsf:metadata name='Abstract_en'/>
	</div>
      </gsf:when>
    </gsf:switch>

    <div id="to-country-votes">
      <gsf:switch>
	<gsf:metadata name='FinishingPos'/>
	<gsf:when test='exists'>
	  <h2>
	    Overall Final Postion: <gsf:metadata name='FinishingPos'/>
	  </h2>
	</gsf:when>
      </gsf:switch>
      
      <gsf:script>
	$(document).ready(function() {
	  append_all_to_country_votes();
	});	

	window.addEventListener("resize", function() { append_all_to_country_votes() });
      </gsf:script>

    </div>
    
    <div style="padding-top: 6px;">
      <hr />
    </div>
    <div id="find-more-content">
      Find more content about this Eurovision entry on-line:

      <ul>

	<gsf:switch>
	  <gsf:metadata name='song_robust_uri' />
	  <gsf:when test='exists'>
	
	    <li>
	      <a target="_blank">
		<xsl:attribute name="href">
		  <gsf:metadata name="song_robust_uri" />
		</xsl:attribute>
		@ DBpedia (direct URI to linked data)
		<gsf:space/>
		<img src="data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAAoAAAAKCAYAAACNMs+9AAAAVklEQVR4Xn3PgQkAMQhDUXfqTu7kTtkpd5RA8AInfArtQ2iRXFWT2QedAfttj2FsPIOE1eCOlEuoWWjgzYaB/IkeGOrxXhqB+uA9Bfcm0lAZuh+YIeAD+cAqSz4kCMUAAAAASUVORK5CYII=" alt="external link" />
	      </a>
	    </li>
	  </gsf:when>
	</gsf:switch>


	<gsf:switch>
	    <gsf:metadata name='youtube_url'/>
	    <gsf:when test='exists'>
	      <li>
		<a target="_blank">
		  <xsl:attribute name="href"><gsf:metadata name="youtube_url"/></xsl:attribute>
		  @ <img src="sites/{$site_name}/collect/{$collName}/images/yt_logo_rgb_dark75.png"/>
		  <gsf:space/>
		  <img src="data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAAoAAAAKCAYAAACNMs+9AAAAVklEQVR4Xn3PgQkAMQhDUXfqTu7kTtkpd5RA8AInfArtQ2iRXFWT2QedAfttj2FsPIOE1eCOlEuoWWjgzYaB/IkeGOrxXhqB+uA9Bfcm0lAZuh+YIeAD+cAqSz4kCMUAAAAASUVORK5CYII=" alt="external link" />
		</a>
	      </li>
	      <li>
		<a target="_blank">
		  <xsl:attribute name="href">
		    //www.google.com/search?q=Eurovision+<gsf:metadata name="Title"/>+<gsf:metadata name="Country"/>
		  </xsl:attribute>
		  Google Web Search
		  <gsf:space/>
		  <img src="data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAAoAAAAKCAYAAACNMs+9AAAAVklEQVR4Xn3PgQkAMQhDUXfqTu7kTtkpd5RA8AInfArtQ2iRXFWT2QedAfttj2FsPIOE1eCOlEuoWWjgzYaB/IkeGOrxXhqB+uA9Bfcm0lAZuh+YIeAD+cAqSz4kCMUAAAAASUVORK5CYII=" alt="external link" />
		</a>
	      </li>
	    </gsf:when>
	    <gsf:otherwise>
	      <li>
		<a target="_blank">
		  <xsl:attribute name="href">
		    //www.google.com/search?q=Eurovision+<gsf:metadata name="Title"/>+<gsf:metadata name="Country"/>
		  </xsl:attribute>
		  Google Web Search (including <img src="sites/{$site_name}/collect/{$collName}/images/yt_logo_rgb_dark75.png"/>)
		  <img src="data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAAoAAAAKCAYAAACNMs+9AAAAVklEQVR4Xn3PgQkAMQhDUXfqTu7kTtkpd5RA8AInfArtQ2iRXFWT2QedAfttj2FsPIOE1eCOlEuoWWjgzYaB/IkeGOrxXhqB+uA9Bfcm0lAZuh+YIeAD+cAqSz4kCMUAAAAASUVORK5CYII=" alt="external link" />
		</a>
		<gsf:space/>
		<!--
		    <a target="_blank">
		      <xsl:attribute name="href">
		        //www.google.com/search?q=Eurovision+<gsf:metadata name="Title"/>+<gsf:metadata name="Country"/>
		      </xsl:attribute>
		      and Google Web Search
		    </a>
		-->
	      </li>
	    </gsf:otherwise>
	</gsf:switch>
	  

	<!--
	<li>
	  <a target="_blank">
	    <xsl:attribute name="href">
	      //www.google.com/search?q=<gsf:metadata name="Creator"/>+<gsf:metadata name="Title"/>+site:genius.com
	    </xsl:attribute>
	    @ Genius.com (lyrics search)
	    <gsf:space/>
	    <img src="data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAAoAAAAKCAYAAACNMs+9AAAAVklEQVR4Xn3PgQkAMQhDUXfqTu7kTtkpd5RA8AInfArtQ2iRXFWT2QedAfttj2FsPIOE1eCOlEuoWWjgzYaB/IkeGOrxXhqB+uA9Bfcm0lAZuh+YIeAD+cAqSz4kCMUAAAAASUVORK5CYII=" alt="external link" />
	  </a>
	</li>
	-->
	
	<li>
	  <a target="_blank">
	    <xsl:attribute name="href">
	      //www.google.com/search?q=<gsf:metadata name="Creator"/>+<gsf:metadata name="Title"/>+site:ultimate-guitar.com
	    </xsl:attribute>
	    Chord/Tab search @ Ultimate-Guitar
	    <gsf:space/>
	    <img src="data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAAoAAAAKCAYAAACNMs+9AAAAVklEQVR4Xn3PgQkAMQhDUXfqTu7kTtkpd5RA8AInfArtQ2iRXFWT2QedAfttj2FsPIOE1eCOlEuoWWjgzYaB/IkeGOrxXhqB+uA9Bfcm0lAZuh+YIeAD+cAqSz4kCMUAAAAASUVORK5CYII=" alt="external link" />
	  </a>
	</li>
	
	<li>

	  <gsf:switch>
	    <gsf:metadata name="musicbrainz.title_id" />
	    <gsf:when test="exists">
	      <xsl:variable name="musicbrainz_title_id"><gsf:metadata name="musicbrainz.title_id" /></xsl:variable>
	      <a target="_blank" href="https://musicbrainz.org/recording/{$musicbrainz_title_id}">
		MusicBrainz Recording ID <gsf:metadata name="musicbrainz.title_id" />
		<gsf:space/>
		<img src="data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAAoAAAAKCAYAAACNMs+9AAAAVklEQVR4Xn3PgQkAMQhDUXfqTu7kTtkpd5RA8AInfArtQ2iRXFWT2QedAfttj2FsPIOE1eCOlEuoWWjgzYaB/IkeGOrxXhqB+uA9Bfcm0lAZuh+YIeAD+cAqSz4kCMUAAAAASUVORK5CYII=" alt="external link" />
	      </a>
	    </gsf:when>
	    <gsf:otherwise>
	      <a target="_blank">
		<xsl:attribute name="href">
		  //www.google.com/search?q=&quot;<gsf:metadata name="Title"/>&quot; site:musicbrainz.org
		</xsl:attribute>
		Linked Open Data song title search @ MusicBrainz
		<gsf:space/>
		<img src="data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAAoAAAAKCAYAAACNMs+9AAAAVklEQVR4Xn3PgQkAMQhDUXfqTu7kTtkpd5RA8AInfArtQ2iRXFWT2QedAfttj2FsPIOE1eCOlEuoWWjgzYaB/IkeGOrxXhqB+uA9Bfcm0lAZuh+YIeAD+cAqSz4kCMUAAAAASUVORK5CYII=" alt="external link" />
	      </a>
	    </gsf:otherwise>
	  </gsf:switch>	      
	</li>

	<gsf:switch>
	  <gsf:metadata name="json.-AssocEssentia" />
	  <gsf:when test="exists">	
	    <li>
	      <xsl:variable name="httpCollection"><xsl:value-of select="$library_name"/>/sites/<xsl:value-of select="$site_name"/>/collect/<xsl:value-of select="/page/pageResponse/collection/@name"/></xsl:variable>
               <xsl:variable name="assocFilePath"><gsf:metadata name="assocfilepath" select="root"/></xsl:variable>
	      <gsf:variable name="AssocEssentiaJSON"><gsf:OID/>-AssocEssentia.json</gsf:variable>
	      <a download="{$AssocEssentiaJSON}" href="{$httpCollection}/index/assoc/{$assocFilePath}/{$AssocEssentiaJSON}">Download Audio Features</a>
	    </li>
	  </gsf:when>
	</gsf:switch>
	
      </ul>
    </div>
    <!--
        google.com/webhp?##q=yourquery&btnI=I
    -->
    
  </xsl:template>
  
  <xsl:template name="documentContent">

    <gsf:switch>
      <gsf:metadata name='FromCountry'/>
      <gsf:when test='exists'>
	<xsl:call-template name="documentContentFromCountry"/>
      </gsf:when>
      <gsf:otherwise>
	<xsl:call-template name="documentContentEntry"/>
      </gsf:otherwise>
    </gsf:switch>

  </xsl:template>

</xsl:stylesheet>
